.\" Copyright (c) 1983, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	From: @(#)listen.2	8.2 (Berkeley) 12/11/93
.\" $FreeBSD: src/lib/libc/sys/listen.2,v 1.7.2.1 1999/09/05 11:16:47 peter Exp $
.\"
.Dd November 3, 1995
.Dt LISTEN 2
.Os BSD 4.2
.Sh NAME
.Nm listen
.Nd listen for connections on a socket
.Sh SYNOPSIS
.Fd #include <sys/socket.h>
.Ft int
.Fn listen "int s" "int backlog"
.Sh DESCRIPTION
To accept connections, a socket
is first created with
.Xr socket 2 ,
a willingness to accept incoming connections and
a queue limit for incoming connections are specified with
.Fn listen ,
and then the connections are
accepted with
.Xr accept 2 .
The
.Fn listen
call applies only to sockets of type
.Dv SOCK_STREAM
or
.Dv SOCK_SEQPACKET.
.Pp
The
.Fa backlog
parameter defines the maximum length the queue of
pending connections may grow to.
If a connection
request arrives with the queue full the client may
receive an error with an indication of
.Er ECONNREFUSED ,
or, if the underlying protocol supports retransmission,
the request may be ignored so that retries may succeed.
.Pp
The
.Xr sysctl 3
MIB variable
.Dq Li kern.somaxconn
specifies a hard limit on
.Fa backlog ;
if a  value greater than
.Li kern.somaxconn
or less than zero is specified,
.Fa backlog
is silently forced to
.Li kern.somaxconn .
.Sh IMPLEMENTATION NOTES
.Pp
In the non-threaded library
.Fn listen
is implemented as the
.Va listen
syscall.
.Pp
In the threaded library, the
.Va listen
syscall is assembled to
.Fn _thread_sys_listen
and
.Fn listen
is implemented as a function which locks
.Va s
for read and write, then calls
.Fn _thread_sys_listen .
Before returning,
.Fn listen
unlocks
.Va s .
.Sh RETURN VALUES
A 0 return value indicates success; -1 indicates an error.
.Sh ERRORS
.Fn Listen 
will fail if:
.Bl -tag -width [EOPNOTSUPP]
.It Bq Er EBADF
The argument
.Fa s
is not a valid descriptor.
.It Bq Er ENOTSOCK
The argument
.Fa s
is not a socket.
.It Bq Er EOPNOTSUPP
The socket is not of a type that supports the operation
.Fn listen .
.El
.Sh SEE ALSO
.Xr accept 2 ,
.Xr connect 2 ,
.Xr socket 2 ,
.Xr sysctl 3 ,
.Xr sysctl 8
.Sh HISTORY
The
.Fn listen
function call appeared in
.Bx 4.2 .
The ability to configure the maximum
.Fa backlog
at run-time, and to use a negative
.Fa backlog
to request the maximum allowable value, was introduced in
.Fx 2.2 .
